%bcond_with tests

Summary:        Python HTTP client/server for asyncio
Name:           python-aiohttp
Version:        3.8.4
Release:        2%{?dist}
License:        Apache-2.0
URL:            https://github.com/aio-libs/aiohttp
Source0:        %{url}/archive/v%{version}/aiohttp-%{version}.tar.gz

Patch3000:      0001-Unbundle-llhttp.patch
Patch3001:      %{url}/pull/7178.patch

BuildRequires:  gcc llhttp-devel python3-devel python3dist(cython)


%description
Python HTTP client/server for asyncio which supports both the client and the server side of the HTTP
protocol, client and server websocket, and webservers with middlewares and pluggable routing.

%package -n python3-aiohttp
Summary:        Python HTTP client/server for asyncio
Recommends:     python3-aiohttp+speedups

%description -n python3-aiohttp
Python HTTP client/server for asyncio which supports both the client and the server side of the HTTP
protocol, client and server websocket, and webservers with middlewares and pluggable routing.

%pyproject_extras_subpkg -n python3-aiohttp speedups

%prep
%autosetup -p 1 -n aiohttp-%{version}
rm -rvf vendor/llhttp
sed -r -i '/--cov=/d' setup.cfg
sed -r -i \
    -e 's/^[[:blank:]]*coverage$/# &/' \
    -e 's/^[[:blank:]]*-e[[:blank:]]+\.$/# &/' \
    -e 's/brotlipy/Brotli/' \
    tox.ini
sed -r -i \
   -e 's/==[^#;]+//' \
   -e 's/^(proxy[-\.]py|python-on-whales|wait-for-it)/# &/' \
   -e 's/^(coverage|pytest-cov|mypy)/# &/' \
   -e 's/^(setuptools-git)/# &/' \
   requirements/*.txt
grep -rl '/\* Generated by Cython' | xargs -r rm -v

%generate_buildrequires
%{pyproject_buildrequires \
    requirements/base.txt %{?with_tests:requirements/test.txt -t}}

%build
mkdir -p .git
%{python3} tools/gen.py
%{python3} -m cython -3 aiohttp/*.pyx -I aiohttp
rm -rvf .git
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files aiohttp

%check
%if %{with tests}
export PYTHONSAFEPATH=1
k="${k-}${k+ and }not test_no_warnings"
ignore="${ignore-} --ignore=tests/test_proxy_functional.py"
k="${k-}${k+ and }not test_client_session_timeout_zero"
k="${k-}${k+ and }not test_static_file_if_match"
k="${k-}${k+ and }not test_static_file_if_none_match"
%pytest ${ignore-} -k "${k-}"
%endif

%files -n python3-aiohttp -f %{pyproject_files}
%doc CHANGES.rst
%doc HISTORY.rst
%doc README.rst

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.8.4-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 Shuo Wang <abushwang@tencent.com> - 3.8.4-1
- initial build
